COMMENT |
== License and (Non)Warranty Information ===================================

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or 
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  
| = Public interface routines =============================================

; - Reads a key from the keyboard -----------------------------------------
                
             IFDEF      __HOOKINT16
OurReadKey      PROC    NEAR
                push    bx
             ELSE
                PUBLIC  OurReadKey
OurReadKey      PROC    FAR
             ENDIF
                pushf
                sti                                    ; make sure IF=1!
 @WaitForKey:   mov     bx, WORD PTR cs:[QueueStart]   ; Get StartOfQueue
                cmp     bx, WORD PTR cs:[QueueEnd]
                je      @WaitForKey
                mov     ax, WORD PTR cs:[KeyQueue][bx] ;
                ROLLOVER
 @NoRolloverG:  mov     WORD PTR cs:[QueueStart], bx
                popf
             IFDEF      __HOOKINT16
                pop     bx
             ENDIF
                ret
OurReadKey      ENDP
                     
; - Checks keyboard status ------------------------------------------------
                
             IFDEF      __HOOKINT16
OurCheckKey     PROC    NEAR
                push    bx
             ELSE
                PUBLIC  OurCheckKey
OurCheckKey     PROC    FAR
             ENDIF
                mov     bx, WORD PTR cs:[QueueStart]   ; Get StartOfQueue
                cmp     bx, WORD PTR cs:[QueueEnd]
                jne     @KeyIsWaiting
                xor     ax, ax
                jmp     SHORT @ExitCheck
 @KeyIsWaiting: mov     ax, WORD PTR cs:[KeyQueue][bx] ; Get KeyCode
 @ExitCheck:    or      ax, ax
             IFDEF      __HOOKINT16
                pop     bx
             ENDIF
                ret
OurCheckKey     ENDP
                
; - Returns the keyboard flags --------------------------------------------
                
             IFNDEF __HOOKINT16
                PUBLIC  GetKeybdFlags
GetKeybdFlags   PROC    FAR
                mov    ax, WORD PTR cs:[ KeybdFlags ]
                ret
GetKeybdFlags   ENDP
             ENDIF

